package devmanuals.com;

import java.util.concurrent.BlockingDeque;
import java.util.concurrent.LinkedBlockingDeque;

class TakeLast implements Runnable{
	BlockingDeque<Integer> bdq;
	 public TakeLast(BlockingDeque<Integer> bdq){
		this.bdq=bdq;
	}
	public void run(){
		int i;
		System.out.println("Element of deque is inserted");
		for(i=0; i<5;i++){
			bdq.add(i);
		try{
			Thread.sleep(1000);
			System.out.println(i);
		}
		catch(InterruptedException e){
			e.printStackTrace();
		}
		}
		System.out.println("Elements of deque = "+bdq);
		System.out.println("Size of deque : "+bdq.size());
		try{ 
		int j =bdq.takeLast();
		 System.out.println("The deleted element = "+j);
		 System.out.println("Remaining elements of deque = "+bdq);
		 System.out.println("Size of remaining deque : "+bdq.size());
	}catch(InterruptedException e){
		e.printStackTrace();
	}
	}
}
public class BdqTakeLast {
	public static void main(String args[]) {
		BlockingDeque<Integer> bdq = new LinkedBlockingDeque<Integer>(5);
		Runnable a = new TakeLast(bdq);
		new Thread(a).start();
	}
}
